/*
   This file maintains the "console gui".

   You should not modify anything in this file (unless
   you want to make the "gui" more interesting).

   There is an array customers[] (declared in CS52500Hw1.c) that
   holds pointers to customer_t data structures, one structure
   for each running customer thread. The structure holds an id
   number, a state, and a run time for each thread. This gui
   walks through that array, and for each thread it finds, it
   draws a representation of that thread in the appropriate
   "room" of the gui (the state of the thread determines the
   appropriate room).
*/

// set the interval of time (in seconds) between console updates
#define UPDATE_INTERVAL 1

void* roomDisplay(void* threadParam)
{
   char entryRoom[]  = "Entry Room (strike any key to create a new cutomer) ========"; // 60 chars
   char diningRoom[] = "Dining Room ================================================";
   char exitRoom[]   = "Exit Room ==================================================";
   char customerString[9];

   int stateCounters[3];  // count the number of customers in each state

   // write the three "room divider" strings
   mvprintw(0, 0, entryRoom);
   mvprintw(20, 0, diningRoom);
   mvprintw(40, 0, exitRoom);

   while(1)  // repeatedly update the console screen buffer
   {
      int i;

      // erase what we wrote into the console screen buffer in the last refresh
      mvprintw( 5, 0, "                                                              ");
      mvprintw(25, 0, "                                                              ");
      mvprintw(45, 0, "                                                              ");

      // walk the customer array, looking for customers to print out.
      stateCounters[0] = 0;
      stateCounters[1] = 0;  // count the number of customers in each state
      stateCounters[2] = 0;
      for (i = 0; i < CUSTOMERS; i++)
         if (customers[i])
         {
            stateCounters[ customers[i]->state ] += 1;
            int x = 8 * stateCounters[ customers[i]->state ];
            int y = 20 * (customers[i]->state) + 5;
            // create an output string containing id number and time remaining in dining state
            sprintf(customerString, "%s(%d)", customers[i]->id, customers[i]->time);
            move(y,x);
            printw(customerString);
         }

      move(0, 0);
      refresh();  // update the console screen
      sleep(UPDATE_INTERVAL);
   }
   return 0;
}//roomDisplay()